﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Security;

namespace PowerMeterManagement
{

    public enum PwrSnsrAcquisitionStatusEnum
    {

        /// AcqComplete -> 1
        AcqComplete = 1,

        /// AcqInProgress -> 0
        AcqInProgress = 0,

        /// AcqStatusUnknown -> -1
        AcqStatusUnknown = -1,
    }

    public enum PwrSnsrTriggerModeEnum
    {

        /// TriggerModeNormal -> 1
        TriggerModeNormal = 1,

        /// TriggerModeAuto -> 2
        TriggerModeAuto = 2,

        /// TriggerModeAutoLevel -> 3
        TriggerModeAutoLevel = 3,

        /// TriggerModeFreerun -> 4
        TriggerModeFreerun = 4,
    }

    public enum PwrSnsrTriggerSlopeEnum
    {

        /// TriggerSlopePositive -> 1
        TriggerSlopePositive = 1,

        /// TriggerSlopeNegative -> 0
        TriggerSlopeNegative = 0,
    }

    public enum PwrSnsrTriggerPositionEnum
    {

        /// TriggerPositionLeft -> 0
        TriggerPositionLeft = 0,

        /// TriggerPositionMiddle -> 1
        TriggerPositionMiddle = 1,

        /// TriggerPositionRight -> 2
        TriggerPositionRight = 2,
    }

    public enum PwrSnsrTriggerSourceEnum
    {

        /// TriggerSourceChannel1 -> 0
        TriggerSourceChannel1 = 0,

        /// TriggerSourceExternal -> 2
        TriggerSourceExternal = 2,

        /// TriggerSourceChannel2 -> 1
        TriggerSourceChannel2 = 1,

        /// TriggerSourceChannel3 -> 3
        TriggerSourceChannel3 = 3,

        /// TriggerSourceChannel4 -> 4
        TriggerSourceChannel4 = 4,

        /// TriggerSourceChannel5 -> 5
        TriggerSourceChannel5 = 5,

        /// TriggerSourceChannel6 -> 6
        TriggerSourceChannel6 = 6,

        /// TriggerSourceChannel7 -> 7
        TriggerSourceChannel7 = 7,

        /// TriggerSourceChannel8 -> 8
        TriggerSourceChannel8 = 8,

        /// TriggerSourceChannel9 -> 9
        TriggerSourceChannel9 = 9,

        /// TriggerSourceChannel10 -> 10
        TriggerSourceChannel10 = 10,

        /// TriggerSourceChannel11 -> 11
        TriggerSourceChannel11 = 11,

        /// TriggerSourceChannel12 -> 12
        TriggerSourceChannel12 = 12,

        /// TriggerSourceChannel13 -> 13
        TriggerSourceChannel13 = 13,

        /// TriggerSourceChannel14 -> 14
        TriggerSourceChannel14 = 14,

        /// TriggerSourceChannel15 -> 15
        TriggerSourceChannel15 = 15,

        /// TriggerSourceChannel16 -> 16
        TriggerSourceChannel16 = 16,

        /// TriggerSourceIndependent -> 17
        TriggerSourceIndependent = 17,
    }

    public enum PwrSnsrUnitsEnum
    {

        /// UnitsdBm -> 0
        UnitsdBm = 0,

        /// Unitswatts -> 1
        Unitswatts = 1,

        /// Unitsvolts -> 2
        Unitsvolts = 2,

        /// UnitsDBV -> 3
        UnitsDBV = 3,

        /// UnitsDBMV -> 4
        UnitsDBMV = 4,

        /// UnitsDBUV -> 5
        UnitsDBUV = 5,
    }

    public enum PwrSnsrMarkerNumberEnum
    {

        /// MarkerNumberMarker1 -> 1
        MarkerNumberMarker1 = 1,

        /// MarkerNumberMarker2 -> 2
        MarkerNumberMarker2 = 2,
    }

    public enum PwrSnsrBandwidthEnum
    {

        /// BandwidthHigh -> 0
        BandwidthHigh = 0,

        /// BandwidthLow -> 1
        BandwidthLow = 1,
    }

    public enum PwrSnsrFilterStateEnum
    {

        /// FilterStateOff -> 0
        FilterStateOff = 0,

        /// FilterStateOn -> 1
        FilterStateOn = 1,

        /// FilterStateAuto -> 2
        FilterStateAuto = 2,
    }

    public enum PwrSnsrPulseUnitsEnum
    {

        /// PulseUnitsWatts -> 0
        PulseUnitsWatts = 0,

        /// PulseUnitsVolts -> 1
        PulseUnitsVolts = 1,
    }

    public enum PwrSnsrCondCodeEnum
    {

        /// CondCodeMeasurementStopped -> -1
        CondCodeMeasurementStopped = -1,

        /// CondCodeError -> 0
        CondCodeError = 0,

        /// CondCodeUnderrange -> 2
        CondCodeUnderrange = 2,

        /// CondCodeOverrange -> 3
        CondCodeOverrange = 3,

        /// CondCodeNormal -> 1
        CondCodeNormal = 1,
    }

    public enum PwrSnsrTriggerStatusEnum
    {

        /// TriggerStatusStopped -> 0
        TriggerStatusStopped = 0,

        /// TriggerStatusPretrig -> 1
        TriggerStatusPretrig = 1,

        /// TriggerStatusWaiting -> 2
        TriggerStatusWaiting = 2,

        /// TriggerStatusAcquiringNew -> 3
        TriggerStatusAcquiringNew = 3,

        /// TriggerStatusAutoTrig -> 4
        TriggerStatusAutoTrig = 4,

        /// TriggerStatusFreerun -> 5
        TriggerStatusFreerun = 5,

        /// TriggerStatusTriggered -> 6
        TriggerStatusTriggered = 6,

        /// TriggerStatusRunning -> 7
        TriggerStatusRunning = 7,
    }

    public enum PwrSnsrTermActionEnum
    {

        /// TermActionStop -> 0
        TermActionStop = 0,

        /// TermActionRestart -> 1
        TermActionRestart = 1,

        /// TermActionDecimate -> 2
        TermActionDecimate = 2,
    }

    public enum PwrSnsrHoldoffModeEnum
    {

        /// HoldoffModeNormal -> 1
        HoldoffModeNormal = 1,

        /// HoldoffModeGap -> 2
        HoldoffModeGap = 2,
    }

    public enum PwrSnsrStatGatingEnum
    {

        /// StatGatingFreeRun -> 0
        StatGatingFreeRun = 0,

        /// StatGatingMarkers -> 1
        StatGatingMarkers = 1,
    }

    public enum PwrSnsrTrigOutModeEnum
    {

        /// TrigOutModeMioOff -> 0
        TrigOutModeMioOff = 0,

        /// TrigOutModeMioPullUp -> 1
        TrigOutModeMioPullUp = 1,

        /// TrigOutModeMioTtl0 -> 2
        TrigOutModeMioTtl0 = 2,

        /// TrigOutModeMioTbRef -> 3
        TrigOutModeMioTbRef = 3,

        /// TrigOutModeMioSweepHigh -> 4
        TrigOutModeMioSweepHigh = 4,

        /// TrigOutModeMioSweepLow -> 5
        TrigOutModeMioSweepLow = 5,

        /// TrigOutModeMioTrigHigh -> 6
        TrigOutModeMioTrigHigh = 6,

        /// TrigOutModeMioTrigLow -> 7
        TrigOutModeMioTrigLow = 7,

        /// TrigOutModeMioMaster -> 8
        TrigOutModeMioMaster = 8,

        /// TrigOutModeMioSlave -> 9
        TrigOutModeMioSlave = 9,
    }

    public enum PwrSnsrMeasBuffGateEnum
    {

        /// MeasBuffGateBurst -> 0
        MeasBuffGateBurst = 0,

        /// MeasBuffGateMarker -> 1
        MeasBuffGateMarker = 1,

        /// MeasBuffGateExtGate -> 2
        MeasBuffGateExtGate = 2,

        /// MeasBuffGatePeriodic -> 3
        MeasBuffGatePeriodic = 3,

        /// MeasBuffGateExtTrig -> 4
        MeasBuffGateExtTrig = 4,
    }

    public enum PwrSnsrMeasBuffStartModeEnum
    {

        /// MeasBuffStartModeImmediate -> 1
        MeasBuffStartModeImmediate = 1,

        /// MeasBuffStartModeExternalEnable -> 2
        MeasBuffStartModeExternalEnable = 2,

        /// MeasBuffStartModeExternalStart -> 3
        MeasBuffStartModeExternalStart = 3,
    }

    public enum PwrSnsrMeasBuffStopReasonEnum
    {

        /// MeasBuffStopReasonCountReached -> 1
        MeasBuffStopReasonCountReached = 1,

        /// MeasBuffStopReasonTimedOut -> 2
        MeasBuffStopReasonTimedOut = 2,

        /// MeasBuffStopReasonBufferOverran -> 3
        MeasBuffStopReasonBufferOverran = 3,

        /// MeasBuffStopReasonNone -> 0
        MeasBuffStopReasonNone = 0,
    }

    public enum PwrSnsrRdgsEnableFlag
    {

        /// SequenceEnable -> 1
        SequenceEnable = 1,

        /// StartTimeEnable -> 2
        StartTimeEnable = 2,

        /// DurationEnable -> 4
        DurationEnable = 4,

        /// MinEnable -> 8
        MinEnable = 8,

        /// AvgEnable -> 16
        AvgEnable = 16,

        /// MaxEnable -> 32
        MaxEnable = 32,
    }

    public enum PwrSnsrErrorCodesEnum
    {

        /// IO_GENERAL -> -2147204588
        IO_GENERAL = -2147204588,

        /// IO_TIMEOUT -> -2147204587
        IO_TIMEOUT = -2147204587,

        /// MODEL_NOT_SUPPORTED -> -2147204586
        MODEL_NOT_SUPPORTED = -2147204586,

        /// INV_PARAMETER -> (int)0xBFFF0078
        /// Error generating expression: Cast expressions are not supported in constants
        INV_PARAMETER = -1073807240,//0xBFFF0078

        /// ERROR_INVALID_SESSION_HANDLE -> (int)((0xBFFA0000L)+0x1190)
        /// Error generating expression: Cast expressions are not supported in constants
        ERROR_INVALID_SESSION_HANDLE = -1074130544,//"(int)((0xBFFA0000L)+0x1190)",

        /// ERROR_STATUS_NOT_AVAILABLE -> (int)((0xBFFA0000L)+0x005D)
        /// Error generating expression: Cast expressions are not supported in constants
        ERROR_STATUS_NOT_AVAILABLE = -1074134947,//"(int)((0xBFFA0000L)+0x005D)",

        /// ERROR_RESET_FAILED -> (int)((0xBFFA0000L)+0x005F)
        /// Error generating expression: Cast expressions are not supported in constants
        ERROR_RESET_FAILED = -1074134945, //"(int)((0xBFFA0000L)+0x005F)",

        /// ERROR_RESOURCE_UNKNOWN -> (int)((0xBFFA0000L)+0x0060)
        /// Error generating expression: Cast expressions are not supported in constants
        ERROR_RESOURCE_UNKNOWN = -1074134944,//"(int)((0xBFFA0000L)+0x0060)",

        /// ERROR_ALREADY_INITIALIZED -> (int)((0xBFFA0000L)+0x0061)
        /// Error generating expression: Cast expressions are not supported in constants
        ERROR_ALREADY_INITIALIZED = -1074134943, //"(int)((0xBFFA0000L)+0x0061)",

        /// ERROR_OUT_OF_MEMORY -> (int)((0xBFFA0000L)+0x0056)
        /// Error generating expression: Cast expressions are not supported in constants
        ERROR_OUT_OF_MEMORY = -1074134954,//"(int)((0xBFFA0000L)+0x0056)",

        /// ERROR_OPERATION_PENDING -> (int)((0xBFFA0000L)+0x0057)
        /// Error generating expression: Cast expressions are not supported in constants
        ERROR_OPERATION_PENDING = -1074134953,//"(int)((0xBFFA0000L)+0x0057)",

        /// ERROR_NULL_POINTER -> (int)((0xBFFA0000L)+0x0058)
        /// Error generating expression: Cast expressions are not supported in constants
        ERROR_NULL_POINTER = -1074134952,//"(int)((0xBFFA0000L)+0x0058)",

        /// ERROR_UNEXPECTED_RESPONSE -> (int)((0xBFFA0000L)+0x0059)
        /// Error generating expression: Cast expressions are not supported in constants
        ERROR_UNEXPECTED_RESPONSE = -1074134951,//"(int)((0xBFFA0000L)+0x0059)",

        /// ERROR_NOT_INITIALIZED -> (int)((0xBFFA0000L)+0x001D)
        /// Error generating expression: Cast expressions are not supported in constants
        ERROR_NOT_INITIALIZED = -1074135011,//"(int)((0xBFFA0000L)+0x001D)",

        /// LIBUSB_ERROR_IO -> -1
        LIBUSB_ERROR_IO = -1,

        /// LIBUSB_ERROR_INVALID_PARAM -> -2
        LIBUSB_ERROR_INVALID_PARAM = -2,

        /// LIBUSB_ERROR_ACCESS -> -3
        LIBUSB_ERROR_ACCESS = -3,

        /// LIBUSB_ERROR_NO_DEVICE -> -4
        LIBUSB_ERROR_NO_DEVICE = -4,

        /// LIBUSB_ERROR_NOT_FOUND -> -5
        LIBUSB_ERROR_NOT_FOUND = -5,

        /// LIBUSB_ERROR_BUSY -> -6
        LIBUSB_ERROR_BUSY = -6,

        /// LIBUSB_ERROR_TIMEOUT -> -7
        LIBUSB_ERROR_TIMEOUT = -7,

        /// LIBUSB_ERROR_OVERFLOW -> -8
        LIBUSB_ERROR_OVERFLOW = -8,

        /// LIBUSB_ERROR_PIPE -> -9
        LIBUSB_ERROR_PIPE = -9,

        /// LIBUSB_ERROR_INTERRUPTED -> -10
        LIBUSB_ERROR_INTERRUPTED = -10,

        /// LIBUSB_ERROR_NO_MEM -> -11
        LIBUSB_ERROR_NO_MEM = -11,

        /// LIBUSB_ERROR_NOT_SUPPORTED -> -12
        LIBUSB_ERROR_NOT_SUPPORTED = -12,

        /// LIBUSB_ERROR_OTHER -> -99
        LIBUSB_ERROR_OTHER = -99,
    }

    public enum PwrSnsrSimSignalType
    {
        PwrSnsrSimSignalPeriodic = 0, /**< Periodic waveform defined by PRF and duty cycle.*/
        PwrSnsrSimSignalBurst = 1, /**< IFF-like burst signal.*/

    }
    /**
    * Unit selector for watts or dBm.
    */
    public enum PwrSnsrSignalUnits
    {
        PwrSnsrSignalUnitsdBm = 0, /**< dBm.*/
        PwrSnsrSignalUnitsWatts = 1, /**< Watts.*/

    }

    /**
	* Simulated signal parameter setting weight.
	*/
    public enum PwrSnsrSimParamWeight
    {
        PwrSnsrWeightNone = 0, /**< Setting is off.*/
        PwrSnsrWeightLight = 1, /**< Setting is lightly applied.*/
        PwrSnsrWeightMedium = 2, /**< Setting is moderately applied.*/
        PwrSnsrWeightHeavy = 3, /**< Setting is heavily applied.*/

    }


    public static class PwrSnsrLib32
    {
        const string DllName = "PwrSnsrLib64.dll";
        public const int SUCCESS = 0;
        public const int CURRENT_TIMEOUT = -2;


        /// <summary>
        /// Send a SCPI command to the instrument.
        /// </summary>
        /// <param name="Vi">The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.</param>
        /// <param name="">Command</param>
        /// <returns>Success (0) or error code.</returns>
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SendSCPICommand")]
        public static extern int PwrSnsr_SendSCPICommand(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Command);


        /// <summary>
        /// Read a SCPI string response from the instrument.
        /// </summary>
        /// <param name="Vi">The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.</param>
        /// <param name="ValueBufferSize">Number of elements in Value.</param>
        /// <param name="ValueActualSize">Number of elements actually written to Value.</param>
        /// <param name="Value">The string returned from the instrument SCPI interface.</param>
        /// <param name="Timeout">Time out in milliseconds for the read operation. Use -1 for infinite and -2 to use the existing time out value.</param>
        /// <returns>Success (0) or error code.</returns>
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadSCPI")]
        public static extern int PwrSnsr_ReadSCPI(int Vi, int ValueBufferSize, ref int ValueActualSize, [In, Out] byte[] Value, int Timeout);


        /// <summary>
        /// Send a SCPI command to the instrument using a named SCPI parser.
        /// </summary>
        /// <param name="Vi">The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.</param>
        /// <param name="name">Name of the parser. Creates a new parser if the name is not already used.</param>
        /// <param name="">Command</param>
        /// <returns>Success (0) or error code.</returns>
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SendSCPIToNamedParser")]
        public static extern int PwrSnsr_SendSCPIToNamedParser(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string name, [In()] [MarshalAs(UnmanagedType.LPStr)] string Command);


        /// <summary>
        /// Read a SCPI string response from the instrument.
        /// </summary>
        /// <param name="Vi">The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.</param>
        /// <param name="name">Name of the parser. If parser doesn't exist, returns ERROR_NULL_POINTER. PwrSnsr_SendSCPIToNamedParser can be used to create a named parser.</param>
        /// <param name="ValueBufferSize">Number of elements in Value.</param>
        /// <param name="ValueActualSize">Number of elements actually written to Value.</param>
        /// <param name="Value">The string returned from the instrument SCPI interface.</param>
        /// <param name="Timeout">Time out in milliseconds for the read operation. Use -1 for infinite and -2 to use the existing time out value.</param>
        /// <returns>Success (0) or error code.</returns>
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadSCPIFromNamedParser")]
        public static extern int PwrSnsr_ReadSCPIFromNamedParser(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string name, int ValueBufferSize, ref int ValueActualSize, byte[] Value, int Timeout);


        /// <summary>
        /// Returns a delimited string of available resources. These strings can be used in the initialize function to open a session to an instrument.
        /// </summary>
        /// <param name="Delimiter">The string used to delimit the list of resources ie. "|", " ", ";", etc.</param>
        /// <param name="ValBufferSize">Number of elements in Val.</param>
        /// <param name="Val">The return string.</param>
        /// <returns>Success (0) or error code.</returns>
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FindResources")]
        public static extern int PwrSnsr_FindResources([In()] [MarshalAs(UnmanagedType.LPStr)] string Delimiter, int ValBufferSize, [In, Out] byte[] Val);
        /**
	    * @brief Gets the minimum supported firmware as an integer. Format is YYYYMMDD.
	    * @return Success (0) or error code. 
	    */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetMinimumSupportedFirmware")]
        public static extern int PwrSnsr_GetMinimumSupportedFirmware(ref int Version);
        /// <summary>
        /// Send a SCPI command as a byte array.
        /// </summary>
        /// <param name="Vi">The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.</param>
        /// <param name="CommandBufferSize">Number of elements in Command.</param>
        /// <param name="Command">Command to send.</param>
        /// <returns>Success (0) or error code.</returns>
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SendSCPIBytes")]
        public static extern int PwrSnsr_SendSCPIBytes(int Vi, int CommandBufferSize, [MarshalAs(UnmanagedType.LPStr)] string Command);


        /// Return Type: int
        ///Vi: SessionID->int
        ///ValueBufferSize: int
        ///Value: char*
        ///ValueActualSize: int*
        ///Timeout: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadSCPIBytes")]
        public static extern int PwrSnsr_ReadSCPIBytes(int Vi, int ValueBufferSize, [In, Out] byte[] Value, ref int ValueActualSize, int Timeout);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Milliseconds: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetTimeOut")]
        public static extern int PwrSnsr_SetTimeOut(int Vi, int Milliseconds);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Val: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTimeOut")]
        public static extern int PwrSnsr_GetTimeOut(int Vi, ref int Val);


        /// Return Type: int
        ///ResourceName: char*
        ///Vi: SessionID*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_init")]
        public static extern int PwrSnsr_init([MarshalAs(UnmanagedType.LPStr)] string ResourceName, ref int Vi);


        /// Return Type: int
        ///Vi: SessionID->int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_close")]
        public static extern int PwrSnsr_close(int Vi);


        /// Return Type: int
        ///Vi: SessionID->int
        ///ErrorCode: int*
        ///ErrorDescriptionBufferSize: int
        ///ErrorDescription: char*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetError")]
        public static extern int PwrSnsr_GetError(int Vi, ref int ErrorCode, int ErrorDescriptionBufferSize, [In, Out] byte[] ErrorDescription);


        /// Return Type: int
        ///Vi: SessionID->int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ClearError")]
        public static extern int PwrSnsr_ClearError(int Vi);


        /// Return Type: int
        ///Vi: SessionID->int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_reset")]
        public static extern int PwrSnsr_reset(int Vi);


        /// Return Type: int
        ///Vi: SessionID->int
        ///TestResult: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_self_test")]
        public static extern int PwrSnsr_self_test(int Vi, ref int TestResult);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_MeasurePower")]
        public static extern int PwrSnsr_MeasurePower(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchCWPower")]
        public static extern int PwrSnsr_FetchCWPower(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_MeasureVoltage")]
        public static extern int PwrSnsr_MeasureVoltage(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///MinWaveformBufferSize: int
        ///MinWaveform: float*
        ///MinWaveformActualSize: int*
        ///MaxWaveformBufferSize: int
        ///MaxWaveform: float*
        ///MaxWaveformActualSize: int*
        ///WaveformArrayBufferSize: int
        ///WaveformArray: float*
        ///WaveformArrayActualSize: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadWaveformMinMax")]
        public static extern int PwrSnsr_ReadWaveformMinMax(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int MinWaveformBufferSize, [In, Out] float[] MinWaveform, ref int MinWaveformActualSize, int MaxWaveformBufferSize, [In, Out] float[] MaxWaveform, ref int MaxWaveformActualSize, int WaveformArrayBufferSize, [In, Out] float[] WaveformArray, ref int WaveformArrayActualSize);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///WaveformArrayBufferSize: int
        ///WaveformArray: float*
        ///WaveformArrayActualSize: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadWaveform")]
        public static extern int PwrSnsr_ReadWaveform(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int WaveformArrayBufferSize, [In, Out] float[] WaveformArray, ref int WaveformArrayActualSize);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///MinWaveformBufferSize: int
        ///MinWaveform: float*
        ///MinWaveformActualSize: int*
        ///MaxWaveformBufferSize: int
        ///MaxWaveform: float*
        ///MaxWaveformActualSize: int*
        ///WaveformArrayBufferSize: int
        ///WaveformArray: float*
        ///WaveformArrayActualSize: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchWaveformMinMax")]
        public static extern int PwrSnsr_FetchWaveformMinMax(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int MinWaveformBufferSize, [In, Out] float[] MinWaveform, ref int MinWaveformActualSize, int MaxWaveformBufferSize, [In, Out] float[] MaxWaveform, ref int MaxWaveformActualSize, int WaveformArrayBufferSize, [In, Out] float[] WaveformArray, ref int WaveformArrayActualSize);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///WaveformArrayBufferSize: int
        ///WaveformArray: float*
        ///WaveformArrayActualSize: int*       
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchWaveform")]
        public static extern int PwrSnsr_FetchWaveform(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int WaveformArrayBufferSize, [In,Out] float[] WaveformArray, ref int WaveformArrayActualSize);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///PulsePeak: float*
        ///PulsePeakValid: PwrSnsrCondCodeEnum*
        ///PulseCycleAvg: float*
        ///PulseCycleAvgValid: PwrSnsrCondCodeEnum*
        ///PulseOnAvg: float*
        ///PulseOnValid: PwrSnsrCondCodeEnum*
        ///IEEETop: float*
        ///IEEETopValid: PwrSnsrCondCodeEnum*
        ///IEEEBottom: float*
        ///IEEEBottomValid: PwrSnsrCondCodeEnum*
        ///Overshoot: float*
        ///OvershootValid: PwrSnsrCondCodeEnum*
        ///Droop: float*
        ///DroopValid: PwrSnsrCondCodeEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchPowerArray")]
        public static extern int PwrSnsr_FetchPowerArray(
                    int Vi,
                    [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel,
                    ref float PulsePeak,
                    ref PwrSnsrCondCodeEnum PulsePeakValid,
                    ref float PulseCycleAvg,
                    ref PwrSnsrCondCodeEnum PulseCycleAvgValid,
                    ref float PulseOnAvg,
                    ref PwrSnsrCondCodeEnum PulseOnValid,
                    ref float IEEETop,
                    ref PwrSnsrCondCodeEnum IEEETopValid,
                    ref float IEEEBottom,
                    ref PwrSnsrCondCodeEnum IEEEBottomValid,
                    ref float Overshoot,
                    ref PwrSnsrCondCodeEnum OvershootValid,
                    ref float Droop,
                    ref PwrSnsrCondCodeEnum DroopValid);





        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Frequency: float*
        ///FrequencyValid: PwrSnsrCondCodeEnum*
        ///Period: float*
        ///PeriodValid: PwrSnsrCondCodeEnum*
        ///Width: float*
        ///WidthValid: PwrSnsrCondCodeEnum*
        ///Offtime: float*
        ///OfftimeValid: PwrSnsrCondCodeEnum*
        ///DutyCycle: float*
        ///DutyCycleValid: PwrSnsrCondCodeEnum*
        ///Risetime: float*
        ///RisetimeValid: PwrSnsrCondCodeEnum*
        ///Falltime: float*
        ///FalltimeValid: PwrSnsrCondCodeEnum*
        ///EdgeDelay: float*
        ///EdgeDelayValid: PwrSnsrCondCodeEnum*
        ///Skew: float*
        ///SkewValid: PwrSnsrCondCodeEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchTimeArray")]
        public static extern int PwrSnsr_FetchTimeArray(
                    int Vi,
                    [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel,
                    ref float Frequency,
                    ref PwrSnsrCondCodeEnum FrequencyValid,
                    ref float Period,
                    ref PwrSnsrCondCodeEnum PeriodValid,
                    ref float Width,
                    ref PwrSnsrCondCodeEnum WidthValid,
                    ref float Offtime,
                    ref PwrSnsrCondCodeEnum OfftimeValid,
                    ref float DutyCycle,
                    ref PwrSnsrCondCodeEnum DutyCycleValid,
                    ref float Risetime,
                    ref PwrSnsrCondCodeEnum RisetimeValid,
                    ref float Falltime,
                    ref PwrSnsrCondCodeEnum FalltimeValid,
                    ref float EdgeDelay,
                    ref PwrSnsrCondCodeEnum EdgeDelayValid,
                    ref float Skew,
                    ref PwrSnsrCondCodeEnum SkewValid);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///PeakAverage: float*
        ///PeakAverageValid: PwrSnsrCondCodeEnum*
        ///PeakMax: float*
        ///PeakMaxValid: PwrSnsrCondCodeEnum*
        ///PeakMin: float*
        ///PeakMinValid: PwrSnsrCondCodeEnum*
        ///PeakToAvgRatio: float*
        ///PeakToAvgRatioValid: PwrSnsrCondCodeEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchCWArray")]
        public static extern int PwrSnsr_FetchCWArray(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float PeakAverage, ref PwrSnsrCondCodeEnum PeakAverageValid, ref float PeakMax, ref PwrSnsrCondCodeEnum PeakMaxValid, ref float PeakMin, ref PwrSnsrCondCodeEnum PeakMinValid, ref float PeakToAvgRatio, ref PwrSnsrCondCodeEnum PeakToAvgRatioValid);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchRiseTime")]
        public static extern int PwrSnsr_FetchRiseTime(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchWidth")]
        public static extern int PwrSnsr_FetchWidth(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchPulsePeak")]
        public static extern int PwrSnsr_FetchPulsePeak(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchPulseOnAverage")]
        public static extern int PwrSnsr_FetchPulseOnAverage(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchPulseCycleAvg")]
        public static extern int PwrSnsr_FetchPulseCycleAvg(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchPRF")]
        public static extern int PwrSnsr_FetchPRF(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchPeriod")]
        public static extern int PwrSnsr_FetchPeriod(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchOvershoot")]
        public static extern int PwrSnsr_FetchOvershoot(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchOfftime")]
        public static extern int PwrSnsr_FetchOfftime(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchIEEETop")]
        public static extern int PwrSnsr_FetchIEEETop(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchIEEEBottom")]
        public static extern int PwrSnsr_FetchIEEEBottom(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchFallTime")]
        public static extern int PwrSnsr_FetchFallTime(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchEdgeDelay")]
        public static extern int PwrSnsr_FetchEdgeDelay(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchDutyCycle")]
        public static extern int PwrSnsr_FetchDutyCycle(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Delay: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTrigDelay")]
        public static extern int PwrSnsr_GetTrigDelay(int Vi, ref float Delay);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Delay: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetTrigDelay")]
        public static extern int PwrSnsr_SetTrigDelay(int Vi, float Delay);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Holdoff: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTrigHoldoff")]
        public static extern int PwrSnsr_GetTrigHoldoff(int Vi, ref float Holdoff);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Holdoff: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetTrigHoldoff")]
        public static extern int PwrSnsr_SetTrigHoldoff(int Vi, float Holdoff);


        /// Return Type: int
        ///Vi: SessionID->int
        ///HoldoffMode: PwrSnsrHoldoffModeEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTrigHoldoffMode")]
        public static extern int PwrSnsr_GetTrigHoldoffMode(int Vi, ref PwrSnsrHoldoffModeEnum HoldoffMode);


        /// Return Type: int
        ///Vi: SessionID->int
        ///HoldoffMode: PwrSnsrHoldoffModeEnum
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetTrigHoldoffMode")]
        public static extern int PwrSnsr_SetTrigHoldoffMode(int Vi, PwrSnsrHoldoffModeEnum HoldoffMode);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Level: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTrigLevel")]
        public static extern int PwrSnsr_GetTrigLevel(int Vi, ref float Level);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Level: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetTrigLevel")]
        public static extern int PwrSnsr_SetTrigLevel(int Vi, float Level);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Mode: PwrSnsrTriggerModeEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTrigMode")]
        public static extern int PwrSnsr_GetTrigMode(int Vi, ref PwrSnsrTriggerModeEnum Mode);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Mode: PwrSnsrTriggerModeEnum
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetTrigMode")]
        public static extern int PwrSnsr_SetTrigMode(int Vi, PwrSnsrTriggerModeEnum Mode);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Position: PwrSnsrTriggerPositionEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTrigPosition")]
        public static extern int PwrSnsr_GetTrigPosition(int Vi, ref PwrSnsrTriggerPositionEnum Position);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Position: PwrSnsrTriggerPositionEnum
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetTrigPosition")]
        public static extern int PwrSnsr_SetTrigPosition(int Vi, PwrSnsrTriggerPositionEnum Position);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Source: PwrSnsrTriggerSourceEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTrigSource")]
        public static extern int PwrSnsr_GetTrigSource(int Vi, ref PwrSnsrTriggerSourceEnum Source);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Source: PwrSnsrTriggerSourceEnum
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetTrigSource")]
        public static extern int PwrSnsr_SetTrigSource(int Vi, PwrSnsrTriggerSourceEnum Source);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Status: PwrSnsrTriggerStatusEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTrigStatus")]
        public static extern int PwrSnsr_GetTrigStatus(int Vi, ref PwrSnsrTriggerStatusEnum Status);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Vernier: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTrigVernier")]
        public static extern int PwrSnsr_GetTrigVernier(int Vi, ref float Vernier);

        /// Return Type: int
        ///Vi: SessionID->int
        ///Vernier: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetTrigVernier")]
        public static extern int PwrSnsr_SetTrigVernier(int Vi, float Vernier);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Slope: PwrSnsrTriggerSlopeEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTrigSlope")]
        public static extern int PwrSnsr_GetTrigSlope(int Vi, ref PwrSnsrTriggerSlopeEnum Slope);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Slope: PwrSnsrTriggerSlopeEnum
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetTrigSlope")]
        public static extern int PwrSnsr_SetTrigSlope(int Vi, PwrSnsrTriggerSlopeEnum Slope);


        /// Return Type: int
        ///Vi: SessionID->int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_Clear")]
        public static extern int PwrSnsr_Clear(int Vi);


        /// Return Type: int
        ///Vi: SessionID->int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_InitiateAquisition")]
        public static extern int PwrSnsr_InitiateAquisition(int Vi);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Val: PwrSnsrAcquisitionStatusEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_Status")]
        public static extern int PwrSnsr_Status(int Vi, ref PwrSnsrAcquisitionStatusEnum Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///InitiateContinuous: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetInitiateContinuous")]
        public static extern int PwrSnsr_SetInitiateContinuous(int Vi, int InitiateContinuous);


        /// Return Type: int
        ///Vi: SessionID->int
        ///InitiateContinuous: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetInitiateContinuous")]
        public static extern int PwrSnsr_GetInitiateContinuous(int Vi, ref int InitiateContinuous);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Enabled: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_EnableCapturePriority")]
        public static extern int PwrSnsr_EnableCapturePriority(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int Enabled);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Enabled: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetEnabled")]
        public static extern int PwrSnsr_GetEnabled(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref int Enabled);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Enabled: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetEnabled")]
        public static extern int PwrSnsr_SetEnabled(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int Enabled);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///SerialNumberBufferSize: int
        ///SerialNumber: char*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetSerialNumber")]
        public static extern int PwrSnsr_GetSerialNumber(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int SerialNumberBufferSize, [In, Out] byte[] SerialNumber);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Count: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetChannelCount")]
        public static extern int PwrSnsr_GetChannelCount(int Vi, ref int Count);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Units: PwrSnsrUnitsEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetUnits")]
        public static extern int PwrSnsr_GetUnits(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrUnitsEnum Units);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Units: PwrSnsrUnitsEnum
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetUnits")]
        public static extern int PwrSnsr_SetUnits(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, PwrSnsrUnitsEnum Units);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CurrentTemp: double*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetCurrentTemp")]
        public static extern int PwrSnsr_GetCurrentTemp(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref double CurrentTemp);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Average: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetAverage")]
        public static extern int PwrSnsr_GetAverage(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref int Average);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Average: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetAverage")]
        public static extern int PwrSnsr_SetAverage(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int Average);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Bandwidth: PwrSnsrBandwidthEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetBandwidth")]
        public static extern int PwrSnsr_GetBandwidth(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrBandwidthEnum Bandwidth);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Bandwidth: PwrSnsrBandwidthEnum
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetBandwidth")]
        public static extern int PwrSnsr_SetBandwidth(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, PwrSnsrBandwidthEnum Bandwidth);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///FilterState: PwrSnsrFilterStateEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetFilterState")]
        public static extern int PwrSnsr_GetFilterState(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrFilterStateEnum FilterState);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///FilterState: PwrSnsrFilterStateEnum
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetFilterState")]
        public static extern int PwrSnsr_SetFilterState(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, PwrSnsrFilterStateEnum FilterState);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///FilterTime: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetFilterTime")]
        public static extern int PwrSnsr_GetFilterTime(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float FilterTime);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///FilterTime: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetFilterTime")]
        public static extern int PwrSnsr_SetFilterTime(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, float FilterTime);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Distal: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetDistal")]
        public static extern int PwrSnsr_GetDistal(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float Distal);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Distal: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetDistal")]
        public static extern int PwrSnsr_SetDistal(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, float Distal);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///EndGate: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetEndGate")]
        public static extern int PwrSnsr_GetEndGate(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float EndGate);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///EndGate: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetEndGate")]
        public static extern int PwrSnsr_SetEndGate(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, float EndGate);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Mesial: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetMesial")]
        public static extern int PwrSnsr_GetMesial(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float Mesial);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Mesial: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetMesial")]
        public static extern int PwrSnsr_SetMesial(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, float Mesial);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Proximal: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetProximal")]
        public static extern int PwrSnsr_GetProximal(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float Proximal);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Proximal: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetProximal")]
        public static extern int PwrSnsr_SetProximal(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, float Proximal);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Units: PwrSnsrPulseUnitsEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetPulseUnits")]
        public static extern int PwrSnsr_GetPulseUnits(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrPulseUnitsEnum Units);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///PwrSnsrPulseUnitsEnum: PwrSnsrPulseUnitsEnum
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetPulseUnits")]
        public static extern int PwrSnsr_SetPulseUnits(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, PwrSnsrPulseUnitsEnum PwrSnsrPulseUnitsEnum);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///StartGate: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetStartGate")]
        public static extern int PwrSnsr_GetStartGate(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float StartGate);

        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///StartGate: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetStartGate")]
        public static extern int PwrSnsr_SetStartGate(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, float StartGate);

        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetCalFactors")]
        public static extern int PwrSnsr_GetCalFactors(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, 
            ref float MaxFrequency, ref float MinFrequency, int FrequencyListBufferSize, [In, Out] float[] FrequencyList, 
            ref int FrequencyListActualSize, int CalFactorListBufferSize, [In, Out] float[] CalFactorList, 
            ref int CalFactorListActualSize, PwrSnsrBandwidthEnum Bandwidth);

        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CalFactor: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetCalFactor")]
        public static extern int PwrSnsr_GetCalFactor(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float CalFactor);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CalFactor: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetCalFactor")]
        public static extern int PwrSnsr_SetCalFactor(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, float CalFactor);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Frequency: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetFrequency")]
        public static extern int PwrSnsr_GetFrequency(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float Frequency);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Frequency: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetFrequency")]
        public static extern int PwrSnsr_SetFrequency(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, float Frequency);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///OffsetdB: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetOffsetdB")]
        public static extern int PwrSnsr_GetOffsetdB(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float OffsetdB);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///OffsetdB: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetOffsetdB")]
        public static extern int PwrSnsr_SetOffsetdB(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, float OffsetdB);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///TempComp: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTempComp")]
        public static extern int PwrSnsr_GetTempComp(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref int TempComp);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///TempComp: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetTempComp")]
        public static extern int PwrSnsr_SetTempComp(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int TempComp);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Timebase: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTimebase")]
        public static extern int PwrSnsr_GetTimebase(int Vi, ref float Timebase);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Timebase: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetTimebase")]
        public static extern int PwrSnsr_SetTimebase(int Vi, float Timebase);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Timespan: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetTimespan")]
        public static extern int PwrSnsr_SetTimespan(int Vi, float Timespan);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Timespan: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTimespan")]
        public static extern int PwrSnsr_GetTimespan(int Vi, ref float Timespan);


        /// Return Type: int
        ///Vi: SessionID->int
        ///MaxTimebase: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetMaxTimebase")]
        public static extern int PwrSnsr_GetMaxTimebase(int Vi, ref float MaxTimebase);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///AvgPower: float*
        ///AvgPowerCondCode: PwrSnsrCondCodeEnum*
        ///MaxPower: float*
        ///MaxPowerCondCode: PwrSnsrCondCodeEnum*
        ///MinPower: float*
        ///MinPowerCondCode: PwrSnsrCondCodeEnum*
        ///PkToAvgRatio: float*
        ///PkToAvgRatioCondCode: PwrSnsrCondCodeEnum*
        ///Marker1Power: float*
        ///Marker1PowerCondCode: PwrSnsrCondCodeEnum*
        ///Marker2Power: float*
        ///Marker2PowerCondCode: PwrSnsrCondCodeEnum*
        ///MarkerRatio: float*
        ///MarkerRatioCondCode: PwrSnsrCondCodeEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchArrayMarkerPower")]
        public static extern int PwrSnsr_FetchArrayMarkerPower(
                    int Vi,
                    [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel,
                    ref float AvgPower,
                    ref PwrSnsrCondCodeEnum AvgPowerCondCode,
                    ref float MaxPower,
                    ref PwrSnsrCondCodeEnum MaxPowerCondCode,
                    ref float MinPower,
                    ref PwrSnsrCondCodeEnum MinPowerCondCode,
                    ref float PkToAvgRatio,
                    ref PwrSnsrCondCodeEnum PkToAvgRatioCondCode,
                    ref float Marker1Power,
                    ref PwrSnsrCondCodeEnum Marker1PowerCondCode,
                    ref float Marker2Power,
                    ref PwrSnsrCondCodeEnum Marker2PowerCondCode,
                    ref float MarkerRatio,
                    ref PwrSnsrCondCodeEnum MarkerRatioCondCode);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Marker: int
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchMarkerAverage")]
        public static extern int PwrSnsr_FetchMarkerAverage(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int Marker, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Marker: int
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchMarkerMax")]
        public static extern int PwrSnsr_FetchMarkerMax(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int Marker, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Marker: int
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchMarkerMin")]
        public static extern int PwrSnsr_FetchMarkerMin(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int Marker, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///AvgPower: float*
        ///AvgPowerCondCode: PwrSnsrCondCodeEnum*
        ///MaxPower: float*
        ///MaxPowerCondCode: PwrSnsrCondCodeEnum*
        ///MinPower: float*
        ///MinPowerCondCode: PwrSnsrCondCodeEnum*
        ///PkToAvgRatio: float*
        ///PkToAvgRatioCondCode: PwrSnsrCondCodeEnum*
        ///Marker1Power: float*
        ///Marker1PowerCondCode: PwrSnsrCondCodeEnum*
        ///Marker2Power: float*
        ///Marker2PowerCondCode: PwrSnsrCondCodeEnum*
        ///MarkerRatio: float*
        ///MarkerRatioCondCode: PwrSnsrCondCodeEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadArrayMarkerPower")]
        public static extern int PwrSnsr_ReadArrayMarkerPower(
                    int Vi,
                    [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel,
                    ref float AvgPower,
                    ref PwrSnsrCondCodeEnum AvgPowerCondCode,
                    ref float MaxPower,
                    ref PwrSnsrCondCodeEnum MaxPowerCondCode,
                    ref float MinPower,
                    ref PwrSnsrCondCodeEnum MinPowerCondCode,
                    ref float PkToAvgRatio,
                    ref PwrSnsrCondCodeEnum PkToAvgRatioCondCode,
                    ref float Marker1Power,
                    ref PwrSnsrCondCodeEnum Marker1PowerCondCode,
                    ref float Marker2Power,
                    ref PwrSnsrCondCodeEnum Marker2PowerCondCode,
                    ref float MarkerRatio,
                    ref PwrSnsrCondCodeEnum MarkerRatioCondCode);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Marker: int
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadMarkerAverage")]
        public static extern int PwrSnsr_ReadMarkerAverage(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int Marker, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Marker: int
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadMarkerMax")]
        public static extern int PwrSnsr_ReadMarkerMax(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int Marker, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Marker: int
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadMarkerMin")]
        public static extern int PwrSnsr_ReadMarkerMin(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int Marker, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchIntervalAvg")]
        public static extern int PwrSnsr_FetchIntervalAvg(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchIntervalFilteredMin")]
        public static extern int PwrSnsr_FetchIntervalFilteredMin(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchIntervalFilteredMax")]
        public static extern int PwrSnsr_FetchIntervalFilteredMax(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchIntervalMax")]
        public static extern int PwrSnsr_FetchIntervalMax(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchIntervalMin")]
        public static extern int PwrSnsr_FetchIntervalMin(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchIntervalPkToAvg")]
        public static extern int PwrSnsr_FetchIntervalPkToAvg(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadIntervalAvg")]
        public static extern int PwrSnsr_ReadIntervalAvg(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadIntervalFilteredMin")]
        public static extern int PwrSnsr_ReadIntervalFilteredMin(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadIntervalFilteredMax")]
        public static extern int PwrSnsr_ReadIntervalFilteredMax(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);

        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadIntervalMax")]
        public static extern int PwrSnsr_ReadIntervalMax(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadIntervalMin")]
        public static extern int PwrSnsr_ReadIntervalMin(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadIntervalPkToAvg")]
        public static extern int PwrSnsr_ReadIntervalPkToAvg(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchIntervalMaxAvg")]
        public static extern int PwrSnsr_FetchIntervalMaxAvg(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchIntervalMinAvg")]
        public static extern int PwrSnsr_FetchIntervalMinAvg(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadIntervalMaxAvg")]
        public static extern int PwrSnsr_ReadIntervalMaxAvg(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadIntervalMinAvg")]
        public static extern int PwrSnsr_ReadIntervalMinAvg(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchMarkerDelta")]
        public static extern int PwrSnsr_FetchMarkerDelta(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchMarkerRatio")]
        public static extern int PwrSnsr_FetchMarkerRatio(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///condCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchMarkerRDelta")]
        public static extern int PwrSnsr_FetchMarkerRDelta(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum condCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchMarkerRRatio")]
        public static extern int PwrSnsr_FetchMarkerRRatio(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadMarkerDelta")]
        public static extern int PwrSnsr_ReadMarkerDelta(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadMarkerRatio")]
        public static extern int PwrSnsr_ReadMarkerRatio(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadMarkerRDelta")]
        public static extern int PwrSnsr_ReadMarkerRDelta(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadMarkerRRatio")]
        public static extern int PwrSnsr_ReadMarkerRRatio(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsValid: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadCWPower")]
        public static extern int PwrSnsr_ReadCWPower(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum IsValid, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///PeakAverage: float*
        ///PeakAverageValid: PwrSnsrCondCodeEnum*
        ///PeakMax: float*
        ///PeakMaxValid: PwrSnsrCondCodeEnum*
        ///PeakMin: float*
        ///PeakMinValid: PwrSnsrCondCodeEnum*
        ///PeakToAvgRatio: float*
        ///PeakToAvgRatioValid: PwrSnsrCondCodeEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadCWArray")]
        public static extern int PwrSnsr_ReadCWArray(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float PeakAverage, ref PwrSnsrCondCodeEnum PeakAverageValid, ref float PeakMax, ref PwrSnsrCondCodeEnum PeakMaxValid, ref float PeakMin, ref PwrSnsrCondCodeEnum PeakMinValid, ref float PeakToAvgRatio, ref PwrSnsrCondCodeEnum PeakToAvgRatioValid);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///PulsePeak: float*
        ///PulsePeakValid: PwrSnsrCondCodeEnum*
        ///PulseCycleAvg: float*
        ///PulseCycleAvgValid: PwrSnsrCondCodeEnum*
        ///PulseOnAvg: float*
        ///PulseOnValid: PwrSnsrCondCodeEnum*
        ///IEEETop: float*
        ///IEEETopValid: PwrSnsrCondCodeEnum*
        ///IEEEBottom: float*
        ///IEEEBottomValid: PwrSnsrCondCodeEnum*
        ///Overshoot: float*
        ///OvershootValid: PwrSnsrCondCodeEnum*
        ///Droop: float*
        ///DroopValid: PwrSnsrCondCodeEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadPowerArray")]
        public static extern int PwrSnsr_ReadPowerArray(
                    int Vi,
                    [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel,
                    ref float PulsePeak,
                    ref PwrSnsrCondCodeEnum PulsePeakValid,
                    ref float PulseCycleAvg,
                    ref PwrSnsrCondCodeEnum PulseCycleAvgValid,
                    ref float PulseOnAvg,
                    ref PwrSnsrCondCodeEnum PulseOnValid,
                    ref float IEEETop,
                    ref PwrSnsrCondCodeEnum IEEETopValid,
                    ref float IEEEBottom,
                    ref PwrSnsrCondCodeEnum IEEEBottomValid,
                    ref float Overshoot,
                    ref PwrSnsrCondCodeEnum OvershootValid,
                    ref float Droop,
                    ref PwrSnsrCondCodeEnum DroopValid);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Frequency: float*
        ///FrequencyValid: PwrSnsrCondCodeEnum*
        ///Period: float*
        ///PeriodValid: PwrSnsrCondCodeEnum*
        ///Width: float*
        ///WidthValid: PwrSnsrCondCodeEnum*
        ///Offtime: float*
        ///OfftimeValid: PwrSnsrCondCodeEnum*
        ///DutyCycle: float*
        ///DutyCycleValid: PwrSnsrCondCodeEnum*
        ///Risetime: float*
        ///RisetimeValid: PwrSnsrCondCodeEnum*
        ///Falltime: float*
        ///FalltimeValid: PwrSnsrCondCodeEnum*
        ///EdgeDelay: float*
        ///EdgeDelayValid: PwrSnsrCondCodeEnum*
        ///Skew: float*
        ///SkewValid: PwrSnsrCondCodeEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadTimeArray")]
        public static extern int PwrSnsr_ReadTimeArray(
                    int Vi,
                    [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel,
                    ref float Frequency,
                    ref PwrSnsrCondCodeEnum FrequencyValid,
                    ref float Period,
                    ref PwrSnsrCondCodeEnum PeriodValid,
                    ref float Width,
                    ref PwrSnsrCondCodeEnum WidthValid,
                    ref float Offtime,
                    ref PwrSnsrCondCodeEnum OfftimeValid,
                    ref float DutyCycle,
                    ref PwrSnsrCondCodeEnum DutyCycleValid,
                    ref float Risetime,
                    ref PwrSnsrCondCodeEnum RisetimeValid,
                    ref float Falltime,
                    ref PwrSnsrCondCodeEnum FalltimeValid,
                    ref float EdgeDelay,
                    ref PwrSnsrCondCodeEnum EdgeDelayValid,
                    ref float Skew,
                    ref PwrSnsrCondCodeEnum SkewValid);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadDutyCycle")]
        public static extern int PwrSnsr_ReadDutyCycle(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadEdgeDelay")]
        public static extern int PwrSnsr_ReadEdgeDelay(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadFallTime")]
        public static extern int PwrSnsr_ReadFallTime(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadIEEEBottom")]
        public static extern int PwrSnsr_ReadIEEEBottom(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadIEEETop")]
        public static extern int PwrSnsr_ReadIEEETop(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadOfftime")]
        public static extern int PwrSnsr_ReadOfftime(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadOvershoot")]
        public static extern int PwrSnsr_ReadOvershoot(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadPeriod")]
        public static extern int PwrSnsr_ReadPeriod(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadPRF")]
        public static extern int PwrSnsr_ReadPRF(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadPulseCycleAvg")]
        public static extern int PwrSnsr_ReadPulseCycleAvg(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadPulseOnAverage")]
        public static extern int PwrSnsr_ReadPulseOnAverage(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadPulsePeak")]
        public static extern int PwrSnsr_ReadPulsePeak(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadRiseTime")]
        public static extern int PwrSnsr_ReadRiseTime(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadWidth")]
        public static extern int PwrSnsr_ReadWidth(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///HorizontalOffset: double*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetHorizontalOffset")]
        public static extern int PwrSnsr_GetHorizontalOffset(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref double HorizontalOffset);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///HorizontalOffset: double
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetHorizontalOffset")]
        public static extern int PwrSnsr_SetHorizontalOffset(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, double HorizontalOffset);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///HorizontalScale: double*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetHorizontalScale")]
        public static extern int PwrSnsr_GetHorizontalScale(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref double HorizontalScale);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///HorizontalScale: double
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetHorizontalScale")]
        public static extern int PwrSnsr_SetHorizontalScale(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, double HorizontalScale);

        /**
	    * @brief Gets vertical center based on current units: <arg> = (range varies by units)
	    * @param Vi The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.
	    * @param Channel Channel number. For single instruments, set this to "CH1".
	    * @param VerticalCenter Vertical center in units
	    * @return Success (0) or error code. 
	    */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetVerticalCenter")]
        public static extern int PwrSnsr_GetVerticalCenter(int Vi, [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float VerticalCenter);
        /**
        * @brief Sets vertical center based on current units: <arg> = (range varies by units)
        * @param Vi The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.
        * @param Channel Channel number. For single instruments, set this to "CH1".
        * @param VerticalCenter Vertical center in units
        * @return Success (0) or error code. 
        */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetVerticalCenter")]
        public static extern int PwrSnsr_SetVerticalCenter(int Vi, [MarshalAs(UnmanagedType.LPStr)] string Channel, float VerticalCenter);
        /**
        * @brief Gets vertical scale based on current units: <arg> = (range varies by units)
        * @param Vi The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.
        * @param Channel Channel number. For single instruments, set this to "CH1".
        * @param VerticalCenter Vertical scale in units
        * @return Success (0) or error code. 
        */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetVerticalScale")]
        public static extern int PwrSnsr_GetVerticalScale(int Vi, [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float VerticalScale);
        /**
        * @brief Sets vertical scale based on current units: <arg> = (range varies by units)
        * @param Vi The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.
        * @param Channel Channel number. For single instruments, set this to "CH1".
        * @param VerticalCenter Vertical scale in units
        * @return Success (0) or error code. 
        */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetVerticalScale")]
        public static extern int PwrSnsr_SetVerticalScale(int Vi, [MarshalAs(UnmanagedType.LPStr)] string Channel, float VerticalScale);

        /**
	    * @brief Gets the channel name by zero index. Note: SCPI commands use a one-based index.
	    * @param Vi The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.
	    * @param Channel Buffer size for Channel
	    * @param Channel Channel number buffer
	    * @param Index the index of the channel
	    * @return Success (0) or error code. 
	    */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetChannelByIndex")]
        public static extern int PwrSnsr_GetChannelByIndex(int Vi, int BuffSize, [In()] [Out] byte[] Channel,
            int Index);
        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///TraceBufferSize: int
        ///Trace: float*
        ///TraceActualSize: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchCCDFTrace")]
        public static extern int PwrSnsr_FetchCCDFTrace(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int TraceBufferSize, [In][Out]float[] Trace, ref int TraceActualSize);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_StatModeReset")]
        public static extern int PwrSnsr_StatModeReset(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Pavg: double*
        ///PavgCond: PwrSnsrCondCodeEnum*
        ///Ppeak: double*
        ///PpeakCond: PwrSnsrCondCodeEnum*
        ///Pmin: double*
        ///PminCond: PwrSnsrCondCodeEnum*
        ///PkToAvgRatio: double*
        ///PkToAvgRatioCond: PwrSnsrCondCodeEnum*
        ///CursorPwr: double*
        ///CursorPwrCond: PwrSnsrCondCodeEnum*
        ///CursorPct: double*
        ///CursorPctCond: PwrSnsrCondCodeEnum*
        ///SampleCount: double*
        ///SampleCountCond: PwrSnsrCondCodeEnum*
        ///SecondsRun: double*
        ///SecondsRunCond: PwrSnsrCondCodeEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchStatMeasurementArray")]
        public static extern int PwrSnsr_FetchStatMeasurementArray(
                    int Vi,
                    [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel,
                    ref double Pavg,
                    ref PwrSnsrCondCodeEnum PavgCond,
                    ref double Ppeak,
                    ref PwrSnsrCondCodeEnum PpeakCond,
                    ref double Pmin,
                    ref PwrSnsrCondCodeEnum PminCond,
                    ref double PkToAvgRatio,
                    ref PwrSnsrCondCodeEnum PkToAvgRatioCond,
                    ref double CursorPwr,
                    ref PwrSnsrCondCodeEnum CursorPwrCond,
                    ref double CursorPct,
                    ref PwrSnsrCondCodeEnum CursorPctCond,
                    ref double SampleCount,
                    ref PwrSnsrCondCodeEnum SampleCountCond,
                    ref double SecondsRun,
                    ref PwrSnsrCondCodeEnum SecondsRunCond);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Percent: double
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: double*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchCCDFPower")]
        public static extern int PwrSnsr_FetchCCDFPower(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, double Percent, ref PwrSnsrCondCodeEnum CondCode, ref double Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Power: double
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: double*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchCCDFPercent")]
        public static extern int PwrSnsr_FetchCCDFPercent(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, double Power, ref PwrSnsrCondCodeEnum CondCode, ref double Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Capture: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetCapture")]
        public static extern int PwrSnsr_GetCapture(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref int Capture);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Capture: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetCapture")]
        public static extern int PwrSnsr_SetCapture(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int Capture);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Gating: PwrSnsrStatGatingEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetGating")]
        public static extern int PwrSnsr_GetGating(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrStatGatingEnum Gating);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Gating: PwrSnsrStatGatingEnum
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetGating")]
        public static extern int PwrSnsr_SetGating(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, PwrSnsrStatGatingEnum Gating);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///TermAction: PwrSnsrTermActionEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTermAction")]
        public static extern int PwrSnsr_GetTermAction(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrTermActionEnum TermAction);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///TermAction: PwrSnsrTermActionEnum
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetTermAction")]
        public static extern int PwrSnsr_SetTermAction(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, PwrSnsrTermActionEnum TermAction);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///TermCount: double*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTermCount")]
        public static extern int PwrSnsr_GetTermCount(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref double TermCount);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///TermCount: double
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetTermCount")]
        public static extern int PwrSnsr_SetTermCount(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, double TermCount);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///TermTime: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTermTime")]
        public static extern int PwrSnsr_GetTermTime(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref int TermTime);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///TermTime: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetTermTime")]
        public static extern int PwrSnsr_SetTermTime(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int TermTime);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///TraceCount: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetCCDFTraceCount")]
        public static extern int PwrSnsr_GetCCDFTraceCount(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref int TraceCount);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///TraceCount: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetCCDFTraceCount")]
        public static extern int PwrSnsr_SetCCDFTraceCount(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int TraceCount);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: double*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchCursorPercent")]
        public static extern int PwrSnsr_FetchCursorPercent(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref double Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: PwrSnsrCondCodeEnum*
        ///Val: double*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchCursorPower")]
        public static extern int PwrSnsr_FetchCursorPower(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref double Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///PercentPosition: double*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetPercentPosition")]
        public static extern int PwrSnsr_GetPercentPosition(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref double PercentPosition);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///PercentPosition: double
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetPercentPosition")]
        public static extern int PwrSnsr_SetPercentPosition(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, double PercentPosition);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///PowerPosition: double
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetPowerPosition")]
        public static extern int PwrSnsr_SetPowerPosition(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, double PowerPosition);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///PowerPosition: double*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetPowerPosition")]
        public static extern int PwrSnsr_GetPowerPosition(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref double PowerPosition);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///SweepLength: int*
        ///SampleRate: double*
        ///SweepRate: double*
        ///SweepTime: double*
        ///StartTime: double*
        ///StatusWord: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetAcqStatusArray")]
        public static extern int PwrSnsr_GetAcqStatusArray(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref int SweepLength, ref double SampleRate, ref double SweepRate, ref double SweepTime, ref double StartTime, ref int StatusWord);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///DetectorTemp: float*
        ///CpuTemp: float*
        ///MioVoltage: float*
        ///VccInt10: float*
        ///VccAux18: float*
        ///Vcc50: float*
        ///Vcc25: float*
        ///Vcc33: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetDiagStatusArray")]
        public static extern int PwrSnsr_GetDiagStatusArray(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float DetectorTemp, ref float CpuTemp, ref float MioVoltage, ref float VccInt10, ref float VccAux18, ref float Vcc50, ref float Vcc25, ref float Vcc33);


        /// Return Type: int
        ///Vi: SessionID->int
        ///MarkerNumber: int
        ///TimePosition: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetMarkerTimePosition")]
        public static extern int PwrSnsr_GetMarkerTimePosition(int Vi, int MarkerNumber, ref float TimePosition);


        /// Return Type: int
        ///Vi: SessionID->int
        ///MarkerNumber: int
        ///TimePosition: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetMarkerTimePosition")]
        public static extern int PwrSnsr_SetMarkerTimePosition(int Vi, int MarkerNumber, float TimePosition);


        /// Return Type: int
        ///Vi: SessionID->int
        ///MarkerNumber: int
        ///PixelPosition: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetMarkerPixelPosition")]
        public static extern int PwrSnsr_GetMarkerPixelPosition(int Vi, int MarkerNumber, ref int PixelPosition);


        /// Return Type: int
        ///Vi: SessionID->int
        ///MarkerNumber: int
        ///PixelPosition: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetMarkerPixelPosition")]
        public static extern int PwrSnsr_SetMarkerPixelPosition(int Vi, int MarkerNumber, int PixelPosition);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///ManufactureDateBufferSize: int
        ///ManufactureDate: char*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetManufactureDate")]
        public static extern int PwrSnsr_GetManufactureDate(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int ManufactureDateBufferSize, [In, Out] byte[] ManufactureDate);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Impedance: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetImpedance")]
        public static extern int PwrSnsr_GetImpedance(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float Impedance);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///PeakPowerMax: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetPeakPowerMax")]
        public static extern int PwrSnsr_GetPeakPowerMax(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float PeakPowerMax);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///PeakPowerMin: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetPeakPowerMin")]
        public static extern int PwrSnsr_GetPeakPowerMin(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float PeakPowerMin);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Attenuation: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetAttenuation")]
        public static extern int PwrSnsr_GetAttenuation(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float Attenuation);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///FactoryCalDateBufferSize: int
        ///FactoryCalDate: char*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetFactoryCalDate")]
        public static extern int PwrSnsr_GetFactoryCalDate(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int FactoryCalDateBufferSize, [In, Out] byte[] FactoryCalDate);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///MinimumTrig: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetMinimumTrig")]
        public static extern int PwrSnsr_GetMinimumTrig(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float MinimumTrig);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///MinFreqHighBandwidth: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetMinFreqHighBandwidth")]
        public static extern int PwrSnsr_GetMinFreqHighBandwidth(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float MinFreqHighBandwidth);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///MaxFreqHighBandwidth: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetMaxFreqHighBandwidth")]
        public static extern int PwrSnsr_GetMaxFreqHighBandwidth(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float MaxFreqHighBandwidth);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///MinFreqLowBandwidth: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetMinFreqLowBandwidth")]
        public static extern int PwrSnsr_GetMinFreqLowBandwidth(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float MinFreqLowBandwidth);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///MaxFreqLowBandwidth: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetMaxFreqLowBandwidth")]
        public static extern int PwrSnsr_GetMaxFreqLowBandwidth(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float MaxFreqLowBandwidth);
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetFpgaVersion")]
        public static extern int PwrSnsr_GetFpgaVersion(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel,
            int ValBufferSize, [In][Out]byte[] Val);
        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///External: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetExternalSkew")]
        public static extern int PwrSnsr_GetExternalSkew(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float External);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///External: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetExternalSkew")]
        public static extern int PwrSnsr_SetExternalSkew(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, float External);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///SlaveSkew: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetSlaveSkew")]
        public static extern int PwrSnsr_GetSlaveSkew(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float SlaveSkew);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///SlaveSkew: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetSlaveSkew")]
        public static extern int PwrSnsr_SetSlaveSkew(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, float SlaveSkew);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///InternalSkew: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetInternalSkew")]
        public static extern int PwrSnsr_GetInternalSkew(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float InternalSkew);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///InternalSkew: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetInternalSkew")]
        public static extern int PwrSnsr_SetInternalSkew(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, float InternalSkew);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_Zero")]
        public static extern int PwrSnsr_Zero(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Val: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ZeroQuery")]
        public static extern int PwrSnsr_ZeroQuery(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref int Val);


        /// Return Type: int
        ///Vi: SessionID->int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_Abort")]
        public static extern int PwrSnsr_Abort(int Vi);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///WaveformArrayBufferSize: int
        ///WaveformArray: float*
        ///WaveformArrayActualSize: int*
        ///Count: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchExtendedWaveform")]
        public static extern int PwrSnsr_FetchExtendedWaveform(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int WaveformArrayBufferSize, ref float WaveformArray, ref int WaveformArrayActualSize, int Count);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///TimePerPoint: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTimePerPoint")]
        public static extern int PwrSnsr_GetTimePerPoint(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float TimePerPoint);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///SweepTime: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetSweepTime")]
        public static extern int PwrSnsr_GetSweepTime(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float SweepTime);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///TraceCount: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetChanTraceCount")]
        public static extern int PwrSnsr_GetChanTraceCount(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref int TraceCount);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///TraceStartTime: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTraceStartTime")]
        public static extern int PwrSnsr_GetTraceStartTime(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float TraceStartTime);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: int*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchDistal")]
        public static extern int PwrSnsr_FetchDistal(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: int*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchMesial")]
        public static extern int PwrSnsr_FetchMesial(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///CondCode: int*
        ///Val: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchProximal")]
        public static extern int PwrSnsr_FetchProximal(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrCondCodeEnum CondCode, ref float Val);

        [StructLayout(LayoutKind.Sequential)]
        public struct PulseInfo
        {

            /// float
            public float Width;

            /// float
            public float Peak;

            /// float
            public float Min;

            /// float
            public float PulseAvg;

            /// float
            public float Position;

            /// float
            public float RiseProximal;

            /// float
            public float RiseDistal;

            /// float
            public float RiseTime;

            /// float
            public float FallProximal;

            /// float
            public float FallDistal;

            /// float
            public float FallTime;
        }


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///PulseInfosSize: int
        ///PulseInfos: PulseInfo*
        ///PulseInfosActualSize: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_FetchAllMultiPulse")]
        public static extern int PwrSnsr_FetchAllMultiPulse(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int PulseInfosSize, [In][Out] PulseInfo[] PulseInfos, ref int PulseInfosActualSize);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Mode: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetTrigOutMode")]
        public static extern int PwrSnsr_SetTrigOutMode(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int Mode);


        /// Return Type: int
        ///Vi: SessionID->int
        ///memChan: char*
        ///ChannelName: char*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SaveToMemoryChannel")]
        public static extern int PwrSnsr_SaveToMemoryChannel(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string memChan, [In()] [MarshalAs(UnmanagedType.LPStr)] string ChannelName);


        /// Return Type: int
        ///Vi: SessionID->int
        ///memChan: char*
        ///ValBufferSize: int
        ///Val: char*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetMemChanArchive")]
        public static extern int PwrSnsr_GetMemChanArchive(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string memChan, int ValBufferSize, [In, Out] byte[] Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///memChan: char*
        ///ArchiveContent: char*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_LoadMemChanFromArchive")]
        public static extern int PwrSnsr_LoadMemChanFromArchive(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string memChan, [In()] [MarshalAs(UnmanagedType.LPStr)] string ArchiveContent);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SaveUserCal")]
        public static extern int PwrSnsr_SaveUserCal(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ClearUserCal")]
        public static extern int PwrSnsr_ClearUserCal(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsAvgSensor: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetIsAvgSensor")]
        public static extern int PwrSnsr_GetIsAvgSensor(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref int IsAvgSensor);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsAvailable: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetIsAvailable")]
        public static extern int PwrSnsr_GetIsAvailable(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref int IsAvailable);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///IsRunning: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetIsRunning")]
        public static extern int PwrSnsr_GetIsRunning(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref int IsRunning);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///ReadingPeriod: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetReadingPeriod")]
        public static extern int PwrSnsr_GetReadingPeriod(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float ReadingPeriod);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Duration: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetDuration")]
        public static extern int PwrSnsr_SetDuration(int Vi, float Duration);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///ValBufferSize: int
        ///Val: int*
        ///ValActualSize: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetSequenceNumbers")]
        public static extern int PwrSnsr_GetSequenceNumbers(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int ValBufferSize, [In,Out] uint[] Val, ref int ValActualSize);
        
        /**
        * @brief Get the average power measurements that were captured during the last call to AcquireMeasurements.
        * @param Vi The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.
        * @param Channel Channel number. For single instruments, set this to "CH1".
        * @param ValBufferSize Buffer size of Val.
        * @param Val Array of average measurements.
        * @param ValActualSize Actual size of Val.
        * @return Success (0) or error code. 
        */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetBufferedAverageMeasurements")]
        public static extern int PwrSnsr_GetBufferedAverageMeasurements(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)]
        string Channel, int ValBufferSize, [In, Out] float[] Val, ref int ValActualSize);

        /**
         * @brief Initiates new acquisition from the measurement buffer system (if acquisition is in the stopped state). 
         * Blocks until the number of measurements for each enabled channel is equal to count, or a time out has occurred.
         * @param Vi The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.
         * @param Timeout Maximum time in seconds to continue acquiring samples. Negative values will be treated as infinite.
         * @param Count Number of samples to acquire.
         * @param StopReason Reason aqcuisition stopped.
         * @param Val Number of samples acquired.
         * @return Success (0) or error code. 
         */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_AcquireMeasurements")]
        public static extern int PwrSnsr_AcquireMeasurements(int Vi, double Timeout, int Count, ref PwrSnsrMeasBuffStopReasonEnum StopReason, ref int Val);
        /**
         * @brief Get the maximum power measurements that were captured during the last call to AcquireMeasurements.
         * @param Vi The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.
         * @param Channel Channel number. For single instruments, set this to "CH1".
         * @param ValBufferSize Size of the buffer.
         * @param Val Array of max measurements.
         * @param ValActualSize Actual size of the returned array in elements.
         * @return Success (0) or error code. 
         */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetMaxMeasurements")]
        public static extern int PwrSnsr_GetMaxMeasurements(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)]string Channel, int ValBufferSize, [In,Out]float[] Val,
            ref int ValActualSize);
        /**
         * @brief Get the minimum power measurements that were captured during the last call to AcquireMeasurements.
         * @param Vi The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.
         * @param Channel Channel number. For single instruments, set this to "CH1".
         * @param ValBufferSize Size of the buffer.
         * @param Val Array of min measurements.
         * @param ValActualSize Actual size of the returned array in elements.
         * @return Success (0) or error code. 
         */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetMinMeasurements")]
        public static extern int PwrSnsr_GetMinMeasurements(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)]string Channel, int ValBufferSize, [In,Out]float[] Val,
            ref int ValActualSize);

        /**
          * @brief Get the time duration samples are captured during each timed mode acquisiton.
          * @param Vi The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.
          * @param Duration The duration in seconds samples are captured during each timed mode acquisiton.
          * @return Success (0) or error code. 
          */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetDuration")]
        public static extern int PwrSnsr_GetDuration(int Vi, ref float Duration);

        /**
        * @brief Get the start time entries in seconds that were captured during the last call to AcquireMeasurements.
        * @param Vi The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.
        * @param Channel Channel number. For single instruments, set this to "CH1".
        * @param ValBufferSize Size of the buffer.
        * @param Val Array of start times.
        * @param ValActualSize Actual size of the returned array in elements.
        * @return Success (0) or error code. 
        */

        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetStartTimes")]
        public static extern int PwrSnsr_GetStartTimes(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)]string Channel, int ValBufferSize, [In, Out]double[] Val,
            ref int ValActualSize);
        /**
         * @brief Get the duration entries in seconds that were captured during the last call to AcquireMeasurements.
         * @param Vi The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.
         * @param Channel Channel number. For single instruments, set this to "CH1".
         * @param ValBufferSize Size of the buffer.
         * @param Val Array of measurement durations in seconds.
         * @param ValActualSize Actual size of the returned buffer.
         * @return Success (0) or error code. 
         */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetDurations")]
        public static extern int PwrSnsr_GetDurations(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)]string Channel, int ValBufferSize, [In, Out]float[] Val,
            ref int ValActualSize);
        /**
         * @brief Starts measurement buffer acquisition. This method allows the user to send a command to the power meter to begin buffering measurements without waiting for all measurements to be completed.
         * Alternately, you can call the AcquireReadings method to start buffering measurements and wait for them to be read from the meter.
         * @param Vi The SessionID handle that you obtain from the PwrSnsr_init function. The handle identifies a particular instrument session.
         * @return Success (0) or error code. 
         */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_StartAcquisition")]
        public static extern int PwrSnsr_StartAcquisition(int Vi);

        /// Return Type: int
        ///Vi: SessionID->int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_StopAcquisition")]
        public static extern int PwrSnsr_StopAcquisition(int Vi);


        /// Return Type: int
        ///Vi: SessionID->int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ClearBuffer")]
        public static extern int PwrSnsr_ClearBuffer(int Vi);


        /// Return Type: int
        ///Vi: SessionID->int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ClearMeasurements")]
        public static extern int PwrSnsr_ClearMeasurements(int Vi);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Val: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetMeasurementsAvailable")]
        public static extern int PwrSnsr_GetMeasurementsAvailable(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref int Val);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Period: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetPeriod")]
        public static extern int PwrSnsr_SetPeriod(int Vi, float Period);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Period: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetPeriod")]
        public static extern int PwrSnsr_GetPeriod(int Vi, ref float Period);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Flag: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetRdgsEnableFlag")]
        public static extern int PwrSnsr_SetRdgsEnableFlag(int Vi, int Flag);


        /// Return Type: int
        ///Vi: SessionID->int
        ///GateMode: PwrSnsrMeasBuffGateEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetGateMode")]
        public static extern int PwrSnsr_GetGateMode(int Vi, ref PwrSnsrMeasBuffGateEnum GateMode);


        /// Return Type: int
        ///Vi: SessionID->int
        ///GateMode: PwrSnsrMeasBuffGateEnum
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetGateMode")]
        public static extern int PwrSnsr_SetGateMode(int Vi, PwrSnsrMeasBuffGateEnum GateMode);


        /// Return Type: int
        ///Vi: SessionID->int
        ///StartMode: PwrSnsrMeasBuffStartModeEnum*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetStartMode")]
        public static extern int PwrSnsr_GetStartMode(int Vi, ref PwrSnsrMeasBuffStartModeEnum StartMode);


        /// Return Type: int
        ///Vi: SessionID->int
        ///StartMode: PwrSnsrMeasBuffStartModeEnum
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetStartMode")]
        public static extern int PwrSnsr_SetStartMode(int Vi, PwrSnsrMeasBuffStartModeEnum StartMode);


        /// Return Type: int
        ///Vi: SessionID->int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_AdvanceReadIndex")]
        public static extern int PwrSnsr_AdvanceReadIndex(int Vi);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///ValBufferSize: int
        ///Val: float*
        ///ValActualSize: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_QueryAverageMeasurements")]
        public static extern int PwrSnsr_QueryAverageMeasurements(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int ValBufferSize, [Out] float[] Val, ref int ValActualSize);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///ValBufferSize: int
        ///Val: float*
        ///ValActualSize: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_QueryStartTimes")]
        public static extern int PwrSnsr_QueryStartTimes(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int ValBufferSize, [Out] float[] Val, ref int ValActualSize);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///ValBufferSize: int
        ///Val: int*
        ///ValActualSize: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_QuerySequenceNumbers")]
        public static extern int PwrSnsr_QuerySequenceNumbers(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int ValBufferSize, [Out] uint[] Val, ref int ValActualSize);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///ValBufferSize: int
        ///Val: float*
        ///ValActualSize: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_QueryDurations")]
        public static extern int PwrSnsr_QueryDurations(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int ValBufferSize, [Out] float[] Val, ref int ValActualSize);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///ValBufferSize: int
        ///Val: float*
        ///ValActualSize: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_QueryMaxMeasurements")]
        public static extern int PwrSnsr_QueryMaxMeasurements(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int ValBufferSize, [Out] float[] Val, ref int ValActualSize);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///ValBufferSize: int
        ///Val: float*
        ///ValActualSize: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_QueryMinMeasurements")]
        public static extern int PwrSnsr_QueryMinMeasurements(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int ValBufferSize, [Out] float[] Val, ref int ValActualSize);


        /// Return Type: int
        ///Vi: SessionID->int
        ///WriteProtection: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetWriteProtection")]
        public static extern int PwrSnsr_GetWriteProtection(int Vi, ref int WriteProtection);


        /// Return Type: int
        ///Vi: SessionID->int
        ///TimedOut: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetTimedOut")]
        public static extern int PwrSnsr_GetTimedOut(int Vi, ref int TimedOut);


        /// Return Type: int
        ///Vi: SessionID->int
        ///SessionCount: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetSessionCount")]
        public static extern int PwrSnsr_GetSessionCount(int Vi, ref int SessionCount);


        /// Return Type: int
        ///Vi: SessionID->int
        ///SessionCount: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetSessionCount")]
        public static extern int PwrSnsr_SetSessionCount(int Vi, int SessionCount);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Seconds: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetSessionTimeout")]
        public static extern int PwrSnsr_SetSessionTimeout(int Vi, float Seconds);


        /// Return Type: int
        ///Vi: SessionID->int
        ///ReturnCount: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetReturnCount")]
        public static extern int PwrSnsr_GetReturnCount(int Vi, ref int ReturnCount);


        /// Return Type: int
        ///Vi: SessionID->int
        ///ReturnCount: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetReturnCount")]
        public static extern int PwrSnsr_SetReturnCount(int Vi, int ReturnCount);


        /// Return Type: int
        ///Vi: SessionID->int
        ///WriteProtection: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetWriteProtection")]
        public static extern int PwrSnsr_SetWriteProtection(int Vi, int WriteProtection);


        /// Return Type: int
        ///Vi: SessionID->int
        ///OverRan: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetOverRan")]
        public static extern int PwrSnsr_GetOverRan(int Vi, ref int OverRan);


        /// Return Type: int
        ///Vi: SessionID->int
        ///MeasurementsAvailable: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetBufferedMeasurementsAvailable")]
        public static extern int PwrSnsr_GetBufferedMeasurementsAvailable(int Vi, ref int MeasurementsAvailable);


        /// Return Type: int
        ///Vi: SessionID->int
        ///MeasBuffEnabled: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetMeasBuffEnabled")]
        public static extern int PwrSnsr_GetMeasBuffEnabled(int Vi, ref int MeasBuffEnabled);


        /// Return Type: int
        ///Vi: SessionID->int
        ///MeasBuffEnabled: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetMeasBuffEnabled")]
        public static extern int PwrSnsr_SetMeasBuffEnabled(int Vi, int MeasBuffEnabled);


        /// Return Type: int
        ///Vi: SessionID->int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ResetContinuousCapture")]
        public static extern int PwrSnsr_ResetContinuousCapture(int Vi);


        /// Return Type: int
        ///Vi: SessionID->int
        ///EndDelay: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetEndDelay")]
        public static extern int PwrSnsr_GetEndDelay(int Vi, ref float EndDelay);


        /// Return Type: int
        ///Vi: SessionID->int
        ///EndDelay: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetEndDelay")]
        public static extern int PwrSnsr_SetEndDelay(int Vi, float EndDelay);


        /// Return Type: int
        ///Vi: SessionID->int
        ///StartQual: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetStartQual")]
        public static extern int PwrSnsr_GetStartQual(int Vi, ref float StartQual);


        /// Return Type: int
        ///Vi: SessionID->int
        ///StartQual: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetStartQual")]
        public static extern int PwrSnsr_SetStartQual(int Vi, float StartQual);


        /// Return Type: int
        ///Vi: SessionID->int
        ///StartDelay: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetStartDelay")]
        public static extern int PwrSnsr_GetStartDelay(int Vi, ref float StartDelay);


        /// Return Type: int
        ///Vi: SessionID->int
        ///StartDelay: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetStartDelay")]
        public static extern int PwrSnsr_SetStartDelay(int Vi, float StartDelay);


        /// Return Type: int
        ///Vi: SessionID->int
        ///EndQual: float*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetEndQual")]
        public static extern int PwrSnsr_GetEndQual(int Vi, ref float EndQual);


        /// Return Type: int
        ///Vi: SessionID->int
        ///EndQual: float
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetEndQual")]
        public static extern int PwrSnsr_SetEndQual(int Vi, float EndQual);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///DataBufferSize: int
        ///Data: unsigned char*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_Write")]
        public static extern int PwrSnsr_Write(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int DataBufferSize, [In] byte[] Data);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Count: int
        ///ValBufferSize: int
        ///Val: unsigned char*
        ///ValActualSize: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadByteArray")]
        public static extern int PwrSnsr_ReadByteArray(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int Count, int ValBufferSize, [In, Out] byte[] Val, ref int ValActualSize);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///Count: int
        ///ValBufferSize: int
        ///Val: unsigned char*
        ///ValActualSize: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_ReadControl")]
        public static extern int PwrSnsr_ReadControl(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int Count, int ValBufferSize, [In, Out] byte[] Val, ref int ValActualSize);


        /// Return Type: int
        ///Vi: SessionID->int
        ///ContinuousCapture: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetContinuousCapture")]
        public static extern int PwrSnsr_SetContinuousCapture(int Vi, int ContinuousCapture);


        /// Return Type: int
        ///Vi: SessionID->int
        ///ContinuousCapture: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetContinuousCapture")]
        public static extern int PwrSnsr_GetContinuousCapture(int Vi, ref int ContinuousCapture);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///ModelBufferSize: int
        ///Model: char*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetModel")]
        public static extern int PwrSnsr_GetModel(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int ModelBufferSize, [In, Out] byte[] Model);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///EnvelopeAverage: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetPeakHoldDecay")]
        public static extern int PwrSnsr_GetPeakHoldDecay(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref int EnvelopeAverage);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///EnvelopeTracking: int*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetPeakHoldTracking")]
        public static extern int PwrSnsr_GetPeakHoldTracking(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref int EnvelopeTracking);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///EnvelopeTracking: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetPeakHoldTracking")]
        public static extern int PwrSnsr_SetPeakHoldTracking(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int EnvelopeTracking);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///FirmwareVersionBufferSize: int
        ///FirmwareVersion: char*
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetFirmwareVersion")]
        public static extern int PwrSnsr_GetFirmwareVersion(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int FirmwareVersionBufferSize, [In, Out] byte[] FirmwareVersion);


        /// Return Type: int
        ///Vi: SessionID->int
        ///Channel: char*
        ///PeakHoldDecay: int
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetPeakHoldDecay")]
        public static extern int PwrSnsr_SetPeakHoldDecay(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, int PeakHoldDecay);

        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetFetchLatency")]
        public static extern int PwrSnsr_SetFetchLatency(int Vi, int Latency);

        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetFetchLatency")]
        public static extern int PwrSnsr_GetFetchLatency(int Vi, ref int Latency);
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetDongleSerialNumber")]
        public static extern int PwrSnsr_GetDongleSerialNumber(ref long val);
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetExpirationDate")]
        public static extern int PwrSnsr_GetExpirationDate(ref int Date);
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetNumberOfCals")]
        public static extern int PwrSnsr_GetNumberOfCals(ref long val);
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_IsLicenseDongleConnected")]
        public static extern int PwrSnsr_IsLicenseDongleConnected(ref int val);

        
      

        /**
        * @brief Open a simulated power meter session
        * @param NumChans Number of channels
        * @param ResourceBuff Buffer to read back the session name, can be NULL
        * @param ResourceBuffSize size of ResourceBuff in characters
        * @param Vi int handle (out parameter)
        * @return Success (0) or error code.
        */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_OpenSimMeter")]
        public static extern int PwrSnsr_OpenSimMeter(int NumChans, [In()] [Out()] byte[] ResourceBuff, int ResourceBuffSize, ref int Vi);

        /**
        * @brief Set the amplitude for the signal on a simulation channel.
        * @param Vi The int handle that you obtain from the PwrSnsr_OpenSimMeter function. The handle identifies a particular instrument session.
        * @param Channel Channel number. For single instruments, set this to "CH1".
        * @param Amplitude The simulated signal level
        * @param Units Units of amplitude in dBm or Watts
        * @return Success (0) or error code.
        */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetSimSignalAmplitude")]
        public static extern int PwrSnsr_SetSimSignalAmplitude(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, float Amplitude, PwrSnsrSignalUnits Units);

        /**
        * @brief Get the amplitude for the signal on a simulation channel.
        * @param Vi The int handle that you obtain from the PwrSnsr_OpenSimMeter function. The handle identifies a particular instrument session.
        * @param Channel Channel number. For single instruments, set this to "CH1".
        * @param Amplitude The simulated signal level (return value).
        * @param Units Units of amplitude in dBm or Watts
        * @return Success (0) or error code.
        */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetSimSignalAmplitude")]
        public static extern int PwrSnsr_GetSimSignalAmplitude(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float Amplitude, PwrSnsrSignalUnits Units);

        /**
        * @brief Set the percent modulation for the signal on a simulation channel.
        * @param Vi The int handle that you obtain from the PwrSnsr_OpenSimMeter function. The handle identifies a particular instrument session.
        * @param Channel Channel number. For single instruments, set this to "CH1".
        * @param Percent The percent modulation.
        * @return Success (0) or error code.
        */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetSimSignalModulation")]
        public static extern int PwrSnsr_SetSimSignalModulation(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, PwrSnsrSimParamWeight Weight);

        /**
        * @brief Get the percent modulation for the signal on a simulation channel.
        * @param Vi The int handle that you obtain from the PwrSnsr_OpenSimMeter function. The handle identifies a particular instrument session.
        * @param Channel Channel number. For single instruments, set this to "CH1".
        * @param Percent The percent modulation (return value).	
        * @return Success (0) or error code.
        */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetSimSignalModulation")]
        public static extern int PwrSnsr_GetSimSignalModulation(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrSimParamWeight Weight);

        /**
        * @brief Set the percent compression for the signal on a simulation channel.
        * @param Vi The int handle that you obtain from the PwrSnsr_OpenSimMeter function. The handle identifies a particular instrument session.
        * @param Channel Channel number. For single instruments, set this to "CH1".
        * @param Percent The percent compression.
        * @return Success (0) or error code.
        */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetSimSignalCompression")]
        public static extern int PwrSnsr_SetSimSignalCompression(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, PwrSnsrSimParamWeight Weight);

        /**
        * @brief Get the percent compression for the signal on a simulation channel.
        * @param Vi The int handle that you obtain from the PwrSnsr_OpenSimMeter function. The handle identifies a particular instrument session.
        * @param Channel Channel number. For single instruments, set this to "CH1".
        * @param Percent The percent compression (return value).	
        * @return Success (0) or error code.
        */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetSimSignalCompression")]
        public static extern int PwrSnsr_GetSimSignalCompression(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrSimParamWeight Weight);

        /**
        * @brief Set the simulated channel signal type.
        * @param Vi The int handle that you obtain from the PwrSnsr_OpenSimMeter function. The handle identifies a particular instrument session.
        * @param Channel Channel number. For single instruments, set this to "CH1".
        * @param SignalType The simulated signal type.
        * @return Success (0) or error code.
        */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetSimSignalType")]
        public static extern int PwrSnsr_SetSimSignalType(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, PwrSnsrSimSignalType SignalType);

        /**
        * @brief Get the simulated channel signal type.
        * @param Vi The int handle that you obtain from the PwrSnsr_OpenSimMeter function. The handle identifies a particular instrument session.
        * @param Channel Channel number. For single instruments, set this to "CH1".
        * @param SignalType The simulated signal type (return value).
        * @return Success (0) or error code.
        */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetSimSignalType")]
        public static extern int PwrSnsr_GetSimSignalType(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref PwrSnsrSimSignalType SignalType);

        /**
        * @brief Set the simulated signal PRF. Valid for Periodic and Burst.
        * @param Vi The int handle that you obtain from the PwrSnsr_OpenSimMeter function. The handle identifies a particular instrument session.
        * @param Channel Channel number. For single instruments, set this to "CH1".
        * @param PRF Pulse repetition frequency in Hz.
        * @return Success (0) or error code.
        */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetSimSignalPRF")]
        public static extern int PwrSnsr_SetSimSignalPRF(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, float PRF);

        /**
        * @brief Get the simulated signal PRF. Valid for Periodic and Burst.
        * @param Vi The int handle that you obtain from the PwrSnsr_OpenSimMeter function. The handle identifies a particular instrument session.
        * @param Channel Channel number. For single instruments, set this to "CH1".
        * @param PRF Pulse repetition frequency in Hz (return value).
        * @return Success (0) or error code.
        */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetSimSignalPRF")]
        public static extern int PwrSnsr_GetSimSignalPRF(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float PRF);

        /**
        * @brief Set the simulated signal duty cycle in percent. Affects Periodic only.
        * @param Vi The int handle that you obtain from the PwrSnsr_OpenSimMeter function. The handle identifies a particular instrument session.
        * @param Channel Channel number. For single instruments, set this to "CH1".
        * @param Duty Duty cycle in percent 
        * @return Success (0) or error code.
        */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_SetSimSignalDuty")]
        public static extern int PwrSnsr_SetSimSignalDuty(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, float Duty);

        /**
        * @brief Get the simulated signal duty cycle in percent. Affects Periodic only.
        * @param Vi The int handle that you obtain from the PwrSnsr_OpenSimMeter function. The handle identifies a particular instrument session.
        * @param Channel Channel number. For single instruments, set this to "CH1".
        * @param Duty Duty cycle in percent (return value).
        * @return Success (0) or error code.
        */
        [DllImport(DllName, CallingConvention = CallingConvention.Cdecl, EntryPoint = "PwrSnsr_GetSimSignalDuty")]
        public static extern int PwrSnsr_GetSimSignalDuty(int Vi, [In()] [MarshalAs(UnmanagedType.LPStr)] string Channel, ref float Duty);



      

    }



}
